#include "LoadWaveFrontObj.h"
#include "ScriptAnalizer.h"
#include <stdio.h>
CWaveFrontObjLoader::CWaveFrontObjLoader()
{
    m_nVertex   = 0;
    m_nIndex    = 0;  
    m_nMaterial = 0;
    m_pVertex   = 0;
    m_pIndex    = 0;
    m_pTexCord  = 0;

}
int CWaveFrontObjLoader::GetObjData(WAVE_FRONT_OBJ_DESC* pwfod)
{
    const int WAVE_FRONT_OBJ_G      = ASM_USER+0;
    const int WAVE_FRONT_OBJ_SRU    = ASM_USER+1;
    const int WAVE_FRONT_OBJ_MINUS  = ASM_USER+2;
    const int WAVE_FRONT_OBJ_MTLLIB = ASM_USER+3;
    const int WAVE_FRONT_OBJ_USEMTL = ASM_USER+4;
    const int WAVE_FRONT_OBJ_V      = ASM_USER+5;
    const int WAVE_FRONT_OBJ_VT     = ASM_USER+6;
    const int WAVE_FRONT_OBJ_VN     = ASM_USER+7;
    const int WAVE_FRONT_OBJ_F      = ASM_USER+8;

	pwfod->nMaterial = 0;
    pwfod->nVertex   = 0;

	int const nOPK       = 8;
	//wavefrontobjt@Cǂݍ݂܂B
	CScriptAnalizer cas;
	INITIALIZE_INFO_DESC iid;
	__int64* pOPK[nOPK+1];
	for(__int64 r=0;r<nOPK;r++)
	{
		pOPK[r] = new __int64[6];
		for(int s=0;s<6;s++)
		{
			pOPK[r][s]=0;
		}
	}
	wchar_t* pOP[10];
	pOP[0] = L" ";
	pOP[1] = L"\"";
	pOP[2] = L"\r\n";
	pOP[3] = L"	";
	pOP[4] = L"-";
	pOP[5] = L"\uFEFF";
	pOP[6] = L"#";
	pOP[7] = L"/";
	pOP[8] = 0;


	pOPK[0][0] = AS_SPACE_WORD;
	pOPK[1][0] = AS_STRING_START;
	pOPK[1][1] = AS_STRING_END;
	pOPK[2][0] = AS_OPERATION_END;
	pOPK[2][1] = AS_SPACE_WORD;
	pOPK[2][2] = AS_ESCAPEBLOCK_END;
	pOPK[2][3] = AS_WORDBREAK;
	pOPK[3][0] = AS_SPACE_WORD;
	pOPK[4][0] = AS_RESERVED_WORD;
	pOPK[5][0] = AS_SPACE_WORD;
	pOPK[6][0] = AS_ESCAPEBLOCK_START;
	pOPK[6][1] = AS_BLOCKWORD_ENTRY +2;
	pOPK[7][0] = AS_RESERVED_WORD;
	pOPK[8] = 0;

	wchar_t* pOPC[10];
	pOPC[0] = L"-";
	pOPC[1] = L"/";
	pOPC[2] = L"g";
	pOPC[3] = L"mtllib";
	pOPC[4] = L"usemtl";
	pOPC[5] = L"v";
	pOPC[6] = L"vt";
	pOPC[7] = L"vn";
	pOPC[8] = L"f";
	pOPC[9] = 0;

	__int64 pOPCK[10];
	pOPCK[0] = WAVE_FRONT_OBJ_MINUS;
	pOPCK[1] = WAVE_FRONT_OBJ_SRU;
	pOPCK[2] = WAVE_FRONT_OBJ_G;
	pOPCK[3] = WAVE_FRONT_OBJ_MTLLIB;
	pOPCK[4] = WAVE_FRONT_OBJ_USEMTL;
	pOPCK[5] = WAVE_FRONT_OBJ_V;
	pOPCK[6] = WAVE_FRONT_OBJ_VT;
	pOPCK[7] = WAVE_FRONT_OBJ_VN;
	pOPCK[8] = WAVE_FRONT_OBJ_F;
	pOPCK[9] = 0;

	wchar_t* pSTB[2];

	pSTB[0] = L"\"";
	pSTB[1] = 0;

	iid.ppOperation = pOP;
	iid.ppOperationKind = pOPK;
	iid.asmEnableNumber = true;
	iid.asmEnableString = true;
	iid.Asd.nStrBlockSet = 1;
	iid.Asd.nTransSet    = 0;
	iid.Asd.pStrBlockStart = pSTB;
	iid.Asd.pStrBlockEnd   = pSTB;
	iid.Asd.pTransStr      = 0;
	iid.Asd.pTransToStr    = 0;
	
	cas.Init(&iid);
	for(int r=0;pOPC[r]!=0;r++)
	{
		cas.AdAsmDistinction(pOPC[r] , pOPCK[r]);
	}

	for(int m1=0;m1<nOPK;m1++)
	{
		delete [] pOPK[m1];
		pOPK[m1] = 0;
	}

	//͊JnB
	ANALIZE_DESC ad;
	int hr;

	ad.pCode = pwfod->pCode;
	ad.nCode = pwfod->nCode;
	
	hr = cas.Analize(&ad);
	if(hr!=0)
	{
		printf("͂ɎsB%s" , cas.GetLastErr());
		cas.Release();
		return -1;
	}
    m_nVertex = cas.AsmCountDistincions(WAVE_FRONT_OBJ_V);
    m_pVertex = new float[m_nVertex*3];
    m_nIndex  = cas.AsmCountDistincions(WAVE_FRONT_OBJ_F);
    m_nIndex *= 3;
    m_pIndex  = new unsigned int[m_nIndex];

    EXE_ASMCODE_DESC ead;
    
    int cVert;
    int isvert;
    int cface_sru;
    int cfindex;
    cfindex = 0;
    int s1;

    cVert = 0;
    cas.AsmSetAssenblyPoint(0);
    while (true)
    {
        hr = cas.AsmGetNextAssembly(&ead);
        if (hr == 1)
        {
            //ׂēǂݐ؂B
            break;
        }
        if (hr != 0)
        {
            swprintf_s(m_ErrMsg, 1000, L"ُI %d", ead.clum);
            return -1;
        }
        switch (ead.kreg[0])
        {
        case WAVE_FRONT_OBJ_G:
            //T|[gȂB
            break;
        case WAVE_FRONT_OBJ_MINUS:
            break;
        case WAVE_FRONT_OBJ_MTLLIB:
            //T|[gȂB
            break;
        case WAVE_FRONT_OBJ_USEMTL:
            //T|[gȂB
            break;
        case WAVE_FRONT_OBJ_V:
            //_B
            s1 = 0;
            m_pVertex[cVert*3 + 0] = 1;
            m_pVertex[cVert*3 + 1] = 1;
            m_pVertex[cVert*3 + 2] = 1;
            for (int s = 1; s<ead.creg && s1<3; s++)
            {
                switch (ead.kreg[s])
                {
                case WAVE_FRONT_OBJ_MINUS:
                    m_pVertex[cVert*3 + s1] = -1;
                    break;
                case ASM_IMM_DOUBLE:
                    m_pVertex[cVert*3 + s1] *= *(double*)ead.reg[s];
                    s1++;
                    break;
                case ASM_IMM_INT:
                    m_pVertex[cVert*3 + s1] *= *(__int64*)ead.reg[s];
                    s1++;
                    break;
                default:
                    swprintf_s(m_ErrMsg, 1000, L"%d s : vʎq3̐lIyhƂ܂B", ead.clum);
                    return -1;
                }
            }
            if (s1<3)
            {
                swprintf_s(m_ErrMsg, 1000, L"%d s : vʎq3̐lIyhƂ܂B", ead.clum);
                return -1;
            }
            cVert += 3;
            break;
        case WAVE_FRONT_OBJ_VT:
            //T|[gȂB
            break;
        case WAVE_FRONT_OBJ_VN:
            //T|[gȂB
            break;
         case WAVE_FRONT_OBJ_F:
            s1 = 0;
            cface_sru = 0;
            //Op`|ST|[gȂB
            for (int s = 1; s<ead.creg && s1<3; s++)
            {

                switch (ead.kreg[s])
                {
                case WAVE_FRONT_OBJ_SRU:
                    //_Wǂނ悤ɂBƂ͓ǂݔ΂B
                    cface_sru++;
                    break;
                case ASM_IMM_INT:
                    switch (cface_sru)
                    {
                    case 0:
                        isvert = 0;
                        break;
                    case 1:
                        isvert = 1;
                        break;
                    case 2:
                        if (ead.kreg[s + 1] == WAVE_FRONT_OBJ_SRU)
                            isvert = 0;
                        else
                            isvert = 2;
                        break;
                    }

                    switch (isvert)
                    {
                    case 0://_xNgCfbNXB
                        m_pIndex[cfindex * 3 + s1] = *(__int64*)ead.reg[s] - 1;
                        s1++;
                        break;
                    case 1://eNX`WCfbNX
                        break;
                    case 2://@xNgCfbNX
                        break;
                    }

                    if (cface_sru >= 2)
                    {
                        cface_sru = 0;
                    }
                    break;
                default:
                    swprintf_s(m_ErrMsg, 1000, L"%d s : fʎq̒_CfbNX͎Rŗ^ĂB", ead.clum);
                    return -1;
                    break;
                }
            }
            if (s1<3)
            {
                swprintf_s(m_ErrMsg, 1000, L"%d s : fʎq̒_CfbNX3^Kv܂B", ead.clum);
                return -1;
            }

            cfindex++;
            break;
        case WAVE_FRONT_OBJ_SRU:
            swprintf_s(m_ErrMsg, 1000, L"%d s : /̓tFCXʎqf̂ƂłȂĂ͂Ȃ܂B", ead.clum);
            return -1;
            break;
        case ASM_UNKNOWN:
            break;
        default:
            return -1;
        }
    }

    pwfod->pIndex   = m_pIndex;
    pwfod->pVertex  = m_pVertex;
    pwfod->pTexCord = m_pTexCord;

    pwfod->nVertex  = m_nVertex;
    pwfod->nIndex   = m_nIndex;

    cas.Release();
	return 0;
}
int CWaveFrontObjLoader::GetObjDataFromFile(wchar_t *pfname , WAVE_FRONT_OBJ_DESC* pwfod)//Xe[gZbg܂B
{
    const int WAVE_FRONT_OBJ_G      = ASM_USER+0;
    const int WAVE_FRONT_OBJ_SRU    = ASM_USER+1;
    const int WAVE_FRONT_OBJ_MINUS  = ASM_USER+2;
    const int WAVE_FRONT_OBJ_MTLLIB = ASM_USER+3;
    const int WAVE_FRONT_OBJ_USEMTL = ASM_USER+4;
    const int WAVE_FRONT_OBJ_V      = ASM_USER+5;
    const int WAVE_FRONT_OBJ_VT     = ASM_USER+6;
    const int WAVE_FRONT_OBJ_VN     = ASM_USER+7;
    const int WAVE_FRONT_OBJ_F      = ASM_USER+8;

    pwfod->nMaterial = 0;
    pwfod->nVertex   = 0;


    FILE* hfile;
    unsigned int nCode;
    wchar_t* pCode;

    if(pfname==0)
    {
        swprintf_s(m_ErrMsg , ERRMSGLEN_WF , L"t@CNULLn܂B");
        return -1;
    }
    hfile = _wfopen(pfname , L"rb");
    if(hfile==0)
    {
        swprintf_s(m_ErrMsg , ERRMSGLEN_WF , L"t@C : %sJ܂B" , pfname);
        return -1;
    }
    fseek(hfile , 0 , SEEK_END);
    nCode = ftell(hfile);
    nCode /= 2;
    fseek(hfile , 0 , SEEK_SET);
	
    
    pCode = new wchar_t[nCode + 3];
    

    fread_s(pCode , nCode*sizeof(wchar_t) , sizeof(wchar_t) , nCode , hfile);

    fclose(hfile);

    pCode[nCode] = L'\r';
    nCode++;
    pCode[nCode] = L'\n';
    nCode++;
    pCode[nCode] = 0;
    nCode++;
	int const nOPK       = 8;
	//wavefrontobjt@Cǂݍ݂܂B
    CScriptAnalizer cas;
	INITIALIZE_INFO_DESC iid;
	__int64* pOPK[nOPK+1];
	for(__int64 r=0;r<nOPK;r++)
	{
		pOPK[r] = new __int64[6];
		for(int s=0;s<6;s++)
		{
			pOPK[r][s]=0;
		}
	}
	wchar_t* pOP[10];
	pOP[0] = L" ";
	pOP[1] = L"\"";
	pOP[2] = L"\r\n";
	pOP[3] = L"	";
	pOP[4] = L"-";
	pOP[5] = L"\uFEFF";
	pOP[6] = L"#";
	pOP[7] = L"/";
	pOP[8] = 0;


	pOPK[0][0] = AS_SPACE_WORD;
	pOPK[1][0] = AS_STRING_START;
	pOPK[1][1] = AS_STRING_END;
	pOPK[2][0] = AS_OPERATION_END;
	pOPK[2][1] = AS_SPACE_WORD;
	pOPK[2][2] = AS_ESCAPEBLOCK_END;
	pOPK[2][3] = AS_WORDBREAK;
	pOPK[3][0] = AS_SPACE_WORD;
	pOPK[4][0] = AS_RESERVED_WORD;
	pOPK[5][0] = AS_SPACE_WORD;
	pOPK[6][0] = AS_ESCAPEBLOCK_START;
	pOPK[6][1] = AS_BLOCKWORD_ENTRY +2;
	pOPK[7][0] = AS_RESERVED_WORD;
	pOPK[8] = 0;

	wchar_t* pOPC[10];
	pOPC[0] = L"-";
	pOPC[1] = L"/";
	pOPC[2] = L"g";
	pOPC[3] = L"mtllib";
	pOPC[4] = L"usemtl";
	pOPC[5] = L"v";
	pOPC[6] = L"vt";
	pOPC[7] = L"vn";
	pOPC[8] = L"f";
	pOPC[9] = 0;

	__int64 pOPCK[10];
	pOPCK[0] = WAVE_FRONT_OBJ_MINUS;
	pOPCK[1] = WAVE_FRONT_OBJ_SRU;
	pOPCK[2] = WAVE_FRONT_OBJ_G;
	pOPCK[3] = WAVE_FRONT_OBJ_MTLLIB;
	pOPCK[4] = WAVE_FRONT_OBJ_USEMTL;
	pOPCK[5] = WAVE_FRONT_OBJ_V;
	pOPCK[6] = WAVE_FRONT_OBJ_VT;
	pOPCK[7] = WAVE_FRONT_OBJ_VN;
	pOPCK[8] = WAVE_FRONT_OBJ_F;
	pOPCK[9] = 0;

	wchar_t* pSTB[2];

	pSTB[0] = L"\"";
	pSTB[1] = 0;

	iid.ppOperation = pOP;
	iid.ppOperationKind = pOPK;
	iid.asmEnableNumber = true;
	iid.asmEnableString = true;
	iid.Asd.nStrBlockSet = 1;
	iid.Asd.nTransSet    = 0;
	iid.Asd.pStrBlockStart = pSTB;
	iid.Asd.pStrBlockEnd   = pSTB;
	iid.Asd.pTransStr      = 0;
	iid.Asd.pTransToStr    = 0;
	
	cas.Init(&iid);
	for(int r=0;pOPC[r]!=0;r++)
	{
		cas.AdAsmDistinction(pOPC[r] , pOPCK[r]);
	}

	for(int m1=0;m1<nOPK;m1++)
	{
		delete [] pOPK[m1];
		pOPK[m1] = 0;
	}

	//͊JnB
	ANALIZE_DESC ad;
	int hr;

	ad.pCode = pCode;
	ad.nCode = nCode;
	
	hr = cas.Analize(&ad);
	if(hr!=0)
	{
		printf("͂ɎsB%s" , cas.GetLastErr());
		cas.Release();
		return -1;
	}

    m_nVertex = cas.AsmCountDistincions(WAVE_FRONT_OBJ_V);
    m_pVertex = new float[m_nVertex*3];
    m_nIndex  = cas.AsmCountDistincions(WAVE_FRONT_OBJ_F);
    m_nIndex *= 3;
    m_pIndex  = new unsigned int[m_nIndex+8];

    EXE_ASMCODE_DESC ead;
    
    float vf3[3];
    int cVert;
    int isvert;
    int cface_sru;
    int cfindex;
    cfindex = 0;
    int s1;
    
    cVert = 0;
    cas.AsmSetAssenblyPoint(0);
    while (true)
    {
        hr = cas.AsmGetNextAssembly(&ead);
        if (hr == 1)
        {
            //ׂēǂݐ؂B
            break;
        }
        if (hr != 0)
        {
            swprintf_s(m_ErrMsg, 1000, L"ُI %d", ead.clum);
            return -1;
        }
        switch (ead.kreg[0])
        {
        case WAVE_FRONT_OBJ_G:
            //T|[gȂB
            break;
        case WAVE_FRONT_OBJ_MINUS:
            break;
        case WAVE_FRONT_OBJ_MTLLIB:
            //T|[gȂB
            break;
        case WAVE_FRONT_OBJ_USEMTL:
            //T|[gȂB
            break;
        case WAVE_FRONT_OBJ_V:
            //_B
            s1 = 0;
            vf3[0] = 1;
            vf3[1] = 1;
            vf3[2] = 1;
            for (int s = 1; s<ead.creg && s1<3; s++)
            {
                switch (ead.kreg[s])
                {
                case WAVE_FRONT_OBJ_MINUS:
                    vf3[s1] = -1;
                    break;
                case ASM_IMM_DOUBLE:
                    vf3[s1] *= *(double*)ead.reg[s];
                    s1++;
                    break;
                case ASM_IMM_INT:
                    vf3[s1] *= *(__int64*)ead.reg[s];
                    s1++;
                    break;
                default:
                    swprintf_s(m_ErrMsg, 1000, L"%d s : vʎq3̐lIyhƂ܂B", ead.clum);
                    return -1;
                }
            }
            if (s1<3)
            {
                swprintf_s(m_ErrMsg, 1000, L"%d s : vʎq3̐lIyhƂ܂B", ead.clum);
                return -1;
            }

            m_pVertex[cVert*3 + 0] = vf3[0];
            m_pVertex[cVert*3 + 1] = vf3[1];
            m_pVertex[cVert*3 + 2] = vf3[2];
            cVert ++;
            break;
        case WAVE_FRONT_OBJ_VT:
            //T|[gȂB
            break;
        case WAVE_FRONT_OBJ_VN:
            //T|[gȂB
            break;
         case WAVE_FRONT_OBJ_F:
            s1 = 0;
            cface_sru = 0;
            //Op`|ST|[gȂB
            for (int s = 1; s<ead.creg && s1<3; s++)
            {

                switch (ead.kreg[s])
                {
                case WAVE_FRONT_OBJ_SRU:
                    //_Wǂނ悤ɂBƂ͓ǂݔ΂B
                    cface_sru++;
                    break;
                case ASM_IMM_INT:
                    switch (cface_sru)
                    {
                    case 0:
                        isvert = 0;
                        break;
                    case 1:
                        isvert = 1;
                        break;
                    case 2:
                        if (ead.kreg[s + 1] == WAVE_FRONT_OBJ_SRU)
                            isvert = 0;
                        else
                            isvert = 2;
                        break;
                    }

                    switch (isvert)
                    {
                    case 0://_xNgCfbNXB
                        m_pIndex[cfindex * 3 + s1] = *(__int64*)ead.reg[s] - 1;
                        s1++;
                        break;
                    case 1://eNX`WCfbNX
                        break;
                    case 2://@xNgCfbNX
                        break;
                    }

                    if (cface_sru >= 2)
                    {
                        cface_sru = 0;
                    }
                    break;
                default:
                    swprintf_s(m_ErrMsg, 1000, L"%d s : fʎq̒_CfbNX͎Rŗ^ĂB", ead.clum);
                    return -1;
                    break;
                }
            }
            if (s1<3)
            {
                swprintf_s(m_ErrMsg, 1000, L"%d s : fʎq̒_CfbNX3^Kv܂B", ead.clum);
                return -1;
            }

            cfindex++;
            break;
        case WAVE_FRONT_OBJ_SRU:
            swprintf_s(m_ErrMsg, 1000, L"%d s : /̓tFCXʎqf̂ƂłȂĂ͂Ȃ܂B", ead.clum);
            return -1;
            break;
        case ASM_UNKNOWN:
            break;
        default:
            return -1;
        }
    }

    pwfod->pIndex   = m_pIndex;
    pwfod->pVertex  = m_pVertex;
    pwfod->pTexCord = m_pTexCord;

    pwfod->nVertex  = m_nVertex;
    pwfod->nIndex   = m_nIndex;

    cas.Release();
    if(pCode!=0)
    {
        delete [] pCode;
        pCode = 0;
    }
	return 0;
}
int CWaveFrontObjLoader::Release()
{
    if(m_pIndex!=0)
    {
        delete [] m_pIndex;
        m_pIndex = 0;
    }
    if(m_pTexCord!=0)
    {
        delete [] m_pTexCord;
        m_pTexCord = 0;
    }
    if(m_pVertex!=0)
    {
        delete [] m_pVertex;
        m_pVertex = 0;
    }
    return 0;
}
CWaveFrontObjLoader::~CWaveFrontObjLoader()
{
	
    
   
}